/*
Test application for super4_64.DLL
(c) All rights reserved TCTEC Pty Ltd

21-April-2023


*/

#include <cstdlib>
#include <iostream>
#include <windows.h>
#include <stdint.h>

#define SUPER4DLL "super4_64" 

using namespace std;

typedef int32_t (CALLBACK *ListRelays) (char [][20]) ;
typedef int32_t (CALLBACK *SetRelays) (char *board, uint8_t mask, uint8_t set) ;
typedef int32_t (CALLBACK *dllversion) () ;

int main(int argc, char *argv[])
{
    HINSTANCE hsuper4DLL; // Handle to super4 DLL
    char relayList[10][20] ;
    int found = 0 ;
    int temp = 0 ;
    int testloop = 0 ;
    int ret = 0 ;
    
    
    ListRelays lpfnListRelays ;
    SetRelays lpfnSetRelays ;
    dllversion lpfndllversion ;
    
    printf("Start\n") ;
    
    hsuper4DLL = LoadLibrary(SUPER4DLL);
    if (!hsuper4DLL)
    {
                    printf("Couldn't load super4 dll\n") ;
                    return (EXIT_SUCCESS) ;
    }
    
    lpfnListRelays = (ListRelays) GetProcAddress(hsuper4DLL, "ListRelays") ;
    lpfnSetRelays = (SetRelays) GetProcAddress(hsuper4DLL, "SetRelays") ;
    lpfndllversion = (dllversion) GetProcAddress(hsuper4DLL, "dllversion") ;
    
    if (!lpfnListRelays || !lpfnSetRelays || !lpfndllversion)
    {
       printf("unable to find function .\n") ;
       
    }else
    {
         found = (lpfnListRelays)(relayList) ;
         printf("return = %d\n", found) ;
         for(temp = 0 ; temp < found; temp++)
         {
           printf("Found: %s\n", relayList[temp]) ;
         }         
     
         
    }
    
    printf("Version: %d\n", (lpfndllversion)() );
    
    if (found > 0)
    {
              for (temp = 0; temp < found; temp += 1)
              {  
                  for(testloop = 0 ; testloop < 2 ; testloop++)
                  {
                      ret = (lpfnSetRelays)(relayList[temp], 1, 1 );
                      printf("return = %d.\n", ret) ;
                      Sleep(100) ;
                      ret = (lpfnSetRelays)(relayList[temp], 2, 1 );
                      printf("return = %d.\n", ret) ;
                      Sleep(100) ;
                      ret = (lpfnSetRelays)(relayList[temp], 4, 1 );
                      printf("return = %d.\n", ret) ;
                      Sleep(100) ;
                      ret = (lpfnSetRelays)(relayList[temp], 8, 1 );
                      printf("return = %d.\n", ret) ;
                      Sleep(100) ;
                       ret = (lpfnSetRelays)(relayList[temp], 1, 0 );
                      printf("return = %d.\n", ret) ;
                      Sleep(100) ;
                      ret = (lpfnSetRelays)(relayList[temp], 2, 0 );
                      printf("return = %d.\n", ret) ;
                      Sleep(100) ;
                      ret = (lpfnSetRelays)(relayList[temp], 4, 0 );
                      printf("return = %d.\n", ret) ;
                      Sleep(100) ;
                      ret = (lpfnSetRelays)(relayList[temp], 8, 0 );
                      printf("return = %d.\n", ret) ;  
                      Sleep(100) ;
                      
                      ret = (lpfnSetRelays)(relayList[temp], 15, 1 );
                      printf("return = %d.\n", ret) ;  
                      Sleep(100) ;
                      
                      ret = (lpfnSetRelays)(relayList[temp], 15, 0 );
                      printf("return = %d.\n", ret) ;  
                      Sleep(100) ;
                      
                      
                      
                  }                                      
                  
              }              
              
    }
    
    
    if (hsuper4DLL != NULL)
    {
        FreeLibrary(hsuper4DLL) ;
    }    
    
    return EXIT_SUCCESS;
}


